const { globSync } = module.require("glob");
const { basename } = module.require("node:path");

// @ts-check

/** @type import('dts-bundle-generator/config-schema').OutputOptions */
const commonOutputParams = {
  exportReferencedTypes: false,
};

/** @type import('dts-bundle-generator/config-schema').BundlerConfig */
const config = {
  compilationOptions: {
    preferredConfigPath: "./tsconfig.declarations.json",
  },

  entries: [
    {
      filePath: "./src/exports/index.ts",
      outFile: "./dist/index.d.ts",
      noCheck: false,
      output: commonOutputParams,
    },
    ...globSync("./src/exports/languages/**/*.ts").map((filePath) => {
      return {
        filePath,
        outFile: `./dist/languages/${basename(filePath.slice(0, -3))}.d.ts`,
        noCheck: false,
        output: commonOutputParams,
      };
    }),
  ],
};

module.exports = config;
